#!/usr/bin/env python
# Copyright (c) 2001, actzero, inc.
# This is a server for the XMethods matrix
# (http://jake.soapware.org/currentXmethodsResults).

import getopt
import sys

sys.path.insert (1, '..')

import SOAP

ident = '$Id: silabserver.py,v 1.10 2001/04/24 23:40:24 blm Exp $'

def echoFloat (inputFloat):
    return inputFloat

def echoFloatArray (inputFloatArray):
    return inputFloatArray

def echoInteger (inputInteger):
    return inputInteger

def echoIntegerArray (inputIntegerArray):
    return inputIntegerArray

def echoString (inputString):
    return inputString

def echoStringArray (inputStringArray):
    return inputStringArray

def echoStruct (inputStruct):
    return inputStruct

def echoStructArray (inputStructArray):
    return inputStructArray

def echoVoid ():
    return SOAP.Void()

def echoDate (inputDate):
    return SOAP.DateTime (inputDate)

def echoBase64 (inputBase64):
    return SOAP.Binary (inputBase64)

namespace = 'http://soapinterop.org/'

DEFAULT_HOST    = 'localhost'
DEFAULT_PORT    = 8080

def usage (error = None):
    sys.stdout = sys.stderr

    if error != None:
        print error

    print """usage: %s [options]
  If a long option shows an argument is mandatory, it's mandatory for the
  equivalent short option also. The default (if any) is shown in brackets.

  -?, --help            display this usage
  -h, --host=HOST       use HOST in the address to listen on [%s]
  -p, --port=PORT       listen on PORT [%d]
""" % (sys.argv[0], DEFAULT_HOST, DEFAULT_PORT),

    sys.exit (0)

def main ():
    host = DEFAULT_HOST
    port = DEFAULT_PORT

    try:
        opts, args = getopt.getopt (sys.argv[1:], '?h:p:',
            ['help', 'host', 'port'])

        for opt, arg in opts:
            if opt in ('-?', '--help'):
                usage ()
            elif opt in ('-h', '--host'):
                host = arg
            elif opt in ('-p', '--port'):
                port = int (arg)
            else:
                raise AttributeError, \
                     "Recognized but unimplemented option `%s'" % opt
    except SystemExit:
        raise
    except:
        usage (sys.exc_info ()[1])

    server = SOAP.SOAPServer ((host, port))

    server.registerFunction (echoFloat, namespace)
    server.registerFunction (echoFloatArray, namespace)
    server.registerFunction (echoInteger, namespace)
    server.registerFunction (echoIntegerArray, namespace)
    server.registerFunction (echoString, namespace)
    server.registerFunction (echoStringArray, namespace)
    server.registerFunction (echoStruct, namespace)
    server.registerFunction (echoStructArray, namespace)
    server.registerFunction (echoVoid, namespace)
    server.registerFunction (echoDate, namespace)
    server.registerFunction (echoBase64, namespace)

    server.serve_forever()

if __name__ == '__main__':
    try:
        sys.exit (main ())
    except KeyboardInterrupt:
        sys.exit (0)
